"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const path_1 = require("path");
const fs_1 = require("fs");
const create_file_from_template_1 = require("./create-file-from-template");
const TEMPLATES_DIR = path_1.resolve(__dirname, '..', 'templates');
const TEMPLATE_PACKAGE_PATH = path_1.join(TEMPLATES_DIR, 'node', 'package.template.json');
const TEMPLATE_JEST_CONFIG_PATH = path_1.join(TEMPLATES_DIR, 'node', 'jest.config.template.js');
const TEMPLATE_TS_CONFIG_PATH = path_1.join(TEMPLATES_DIR, 'node', 'tsconfig.template.json');
const TEMPLATE_TS_CONFIG_BUILD_PATH = path_1.join(TEMPLATES_DIR, 'node', 'tsconfig.build.template.json');
const TEMPLATE_TSLINT_CONFIG_PATH = path_1.join(TEMPLATES_DIR, 'node', 'tslint.template.json');
const TEMPLATE_EDITOR_CONFIG_PATH = path_1.join(TEMPLATES_DIR, 'node', '.editorconfig');
const TEMPLATE_GITIGNORE_PATH = path_1.join(TEMPLATES_DIR, 'node', '.gitignore');
const TEMPLATE_INDEX = path_1.join(TEMPLATES_DIR, 'node', 'index.template.ts');
exports.createNode = async (args) => {
    const { projectName, email, authorName, githubUser, projectRoot, } = args;
    create_file_from_template_1.createFileFromTemplate({
        templatePath: TEMPLATE_PACKAGE_PATH,
        outPath: path_1.join(projectRoot, 'package.json'),
        params: {
            projectName: projectName,
            email,
            authorName,
            githubUser,
        }
    });
    create_file_from_template_1.createFileFromTemplate({
        templatePath: TEMPLATE_JEST_CONFIG_PATH,
        outPath: path_1.join(projectRoot, 'jest.config.js'),
    });
    create_file_from_template_1.createFileFromTemplate({
        templatePath: TEMPLATE_TS_CONFIG_PATH,
        outPath: path_1.join(projectRoot, 'tsconfig.json'),
    });
    create_file_from_template_1.createFileFromTemplate({
        templatePath: TEMPLATE_TS_CONFIG_BUILD_PATH,
        outPath: path_1.join(projectRoot, 'tsconfig.build.json'),
    });
    create_file_from_template_1.createFileFromTemplate({
        templatePath: TEMPLATE_TSLINT_CONFIG_PATH,
        outPath: path_1.join(projectRoot, 'tslint.json'),
    });
    create_file_from_template_1.createFileFromTemplate({
        templatePath: TEMPLATE_EDITOR_CONFIG_PATH,
        outPath: path_1.join(projectRoot, '.editorconfig'),
    });
    create_file_from_template_1.createFileFromTemplate({
        templatePath: TEMPLATE_GITIGNORE_PATH,
        outPath: path_1.join(projectRoot, '.gitignore'),
    });
    const SRC_DIR = path_1.join(projectRoot, 'src');
    if (!fs_1.existsSync(SRC_DIR)) {
        fs_1.mkdirSync(SRC_DIR);
    }
    create_file_from_template_1.createFileFromTemplate({
        templatePath: TEMPLATE_INDEX,
        outPath: path_1.join(SRC_DIR, 'index.ts'),
    });
};
